
#ifndef DISTRIBUTORCORE_SOCKETPOSIX_HPP
#define DISTRIBUTORCORE_SOCKETPOSIX_HPP 1


#include "DistributorBroadcastCore.hpp"



#if HAVE_POSIX > 0

/**
\brief
*/
class DistributorCore_SocketPOSIX :
public DistributorCore_Socket {
private:

	class Impl;
	SHARED_PTR< Impl> pimpl;

public:

	//! Init.
	explicit DistributorCore_SocketPOSIX( DistributorCore_Adapter& adapter);
	//! Ende.
	virtual ~DistributorCore_SocketPOSIX( void);

	//! Socket öffnen
	bool open( const std::vector< std::string>& def_ifaces, const std::string& iface, uint16_t port, std::string& self);
	//! Socket schließen
	void close( void);
	//! Paket senden
	ssize_t writev( const struct iovec* const iov, int iov_cnt);
	//! Paket emfangen, non-blocking
	ssize_t recvfrom( void* buf, size_t len, std::string& from_addr);

};

#endif // #if HAVE_POSIX > 0

#endif // DISTRIBUTORCORE_SOCKETPOSIX_HPP

