
#ifndef DISTRIBUTORCORE_SOCKETWINSOCK
#define DISTRIBUTORCORE_SOCKETWINSOCK 1

#include "DistributorBroadcastCore.hpp"

#if HAVE_WINSOCK > 0




/**
\brief
*/
class DistributorCore_SocketWINSOCK : public DistributorCore_Socket
{
private:
	class Impl;
	SHARED_PTR< Impl> pimpl;
public:
	//! Init.
	explicit DistributorCore_SocketWINSOCK( DistributorCore_Adapter& adapter);
	//! Ende.
	virtual ~DistributorCore_SocketWINSOCK( void);

	//! Socket öffnen
	bool open( const std::vector< std::string>& def_ifaces, const std::string& iface, uint16_t port, std::string& self);
	//! Socket schließen
	void close( void);
	//! Paket senden
	ssize_t writev( const struct iovec* const iov, int iov_cnt);
	//! Paket emfangen, non-blocking
	ssize_t recvfrom( void* buf, size_t len, std::string& from_addr);
};




#endif // #if HAVE_WINSOCK > 0


#endif // #ifndef DISTRIBUTORCORE_SOCKETWINSOCK
